//--OpenObject for SuperCollider by Julian Rohrhuber
//--this demo was made at subnet/salzburg 2009


//--sequencer with processing gui
s.boot
OpenObject.start


(
SynthDef(\subnet_step16, {|amp= 1, pan= 0, freq= 400, modAmp= 1, lag= 0.05, rate= 8, freqPat= #[0, 1, 0, 0, 0, 0, 0, 0.4, 0, 0, 1, 1, 0, 1, 0, 0], ampPat= #[1, 0, 0.2, 0.1, 0, 1, 0, 0.1, 1, 0, 0.5, 1, 0.5, 0, 0.2, 0.1]|
	var src, trig, freqSeq, ampSeq, pm;
	trig= Impulse.kr(rate);
	freqSeq= Demand.kr(trig, 0, Dseq(freqPat, inf));
	ampSeq= Demand.kr(trig, 0, Dseq(ampPat, inf));
	pm= SinOsc.ar(Lag2.kr(freqSeq, lag)+1*freq, Decay2.kr(trig, lag)*2pi, Lag.kr(modAmp, lag));
	src= SinOsc.ar(0, pm, Lag.kr(ampSeq, lag));
	Out.ar(0, Pan2.ar(src, pan, amp));
}).add;
)

(
a= Synth(\subnet_step16).publish(\seq);
c= {|name, index, val| a.getn(name, 16, {|x| a.setn(name, x.put(index, val))})};	//helper function
c.publish(\seqHelper);
)


//now open the file openobject_demo05_processing.pde in processing


//--clean up
a.free;
OpenObject.end
s.quit
