import netP5.*;
import oscP5.*;                  //required 3rd party lib from sojamo.de
import controlP5.*;
NetAddress sc;
OscP5 osc;
ControlP5 ctrl;

void setup() {
  size(600, 400);
  smooth();
  //stroke(255);
  osc= new OscP5(this, 12000);
  sc= new NetAddress("127.0.0.1", 57120);
  ctrl= new ControlP5(this);
  int i;
  for(i= 0; i<16; i++) {
    ctrl.addKnob("freq"+i, 0, 1, 0, i*35+5, 30, 30);  //name, min, max, default, x, y, size
  }
  for(i= 0; i<16; i++) {
    ctrl.addKnob("amp"+i, 0, 1, 0, i*35+5, 90, 30);  //name, min, max, default, x, y, size
  }
  ctrl.addKnob("amp", 0, 1.5, 1, 5, 160, 60);
  ctrl.addKnob("freq", 50, 1000, 400, 105, 160, 60);
  ctrl.addKnob("pan", -1, 1, 0, 205, 160, 60);
  ctrl.addKnob("modAmp", 1, 50, 1, 305, 160, 60);
  ctrl.addKnob("lag", 0, 0.5, 0.05, 405, 160, 60);
  ctrl.addKnob("rate", 0.5, 50, 8, 505, 160, 60);
}
void draw() {
  background(0);
}
void amp(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "amp", val}, sc);
}
void freq(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "freq", val}, sc);
}
void pan(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "pan", val}, sc);
}
void modAmp(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "modAmp", val}, sc);
}
void lag(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "lag", val}, sc);
}
void rate(float val) {
  osc.send("/oo", new Object[] {"seq", "set", "rate", val}, sc);
}

void freq0(float val) {freqpat(0, val);}
void freq1(float val) {freqpat(1, val);}
void freq2(float val) {freqpat(2, val);}
void freq3(float val) {freqpat(3, val);}
void freq4(float val) {freqpat(4, val);}
void freq5(float val) {freqpat(5, val);}
void freq6(float val) {freqpat(6, val);}
void freq7(float val) {freqpat(7, val);}
void freq8(float val) {freqpat(8, val);}
void freq9(float val) {freqpat(9, val);}
void freq10(float val) {freqpat(10, val);}
void freq11(float val) {freqpat(11, val);}
void freq12(float val) {freqpat(12, val);}
void freq13(float val) {freqpat(13, val);}
void freq14(float val) {freqpat(14, val);}
void freq15(float val) {freqpat(15, val);}
void amp0(float val) {amppat(0, val);}
void amp1(float val) {amppat(1, val);}
void amp2(float val) {amppat(2, val);}
void amp3(float val) {amppat(3, val);}
void amp4(float val) {amppat(4, val);}
void amp5(float val) {amppat(5, val);}
void amp6(float val) {amppat(6, val);}
void amp7(float val) {amppat(7, val);}
void amp8(float val) {amppat(8, val);}
void amp9(float val) {amppat(9, val);}
void amp10(float val) {amppat(10, val);}
void amp11(float val) {amppat(11, val);}
void amp12(float val) {amppat(12, val);}
void amp13(float val) {amppat(13, val);}
void amp14(float val) {amppat(14, val);}
void amp15(float val) {amppat(15, val);}

void freqpat(int index, float val) {
  osc.send("/oo", new Object[] {"seqHelper", "value", "freqPat", index, val}, sc);
}
void amppat(int index, float val) {
  osc.send("/oo", new Object[] {"seqHelper", "value", "ampPat", index, val}, sc);
}

