//--OpenObject for SuperCollider by Julian Rohrhuber
//--this short demo was made at subnet/salzburg 2009

s.boot						//start the server
OpenObject.start
(
SynthDef(\subnetFM, {|freq= 500, amp= 0.5, gate= 1, pan= 0, freq1= 451, amp1= 623, freq2= 579, amp2= 328, freq3= 5, amp3= 776|
	var env= EnvGen.kr(Env.asr(0.01, 1, 0.2), gate);
	var fm3= SinOsc.ar(freq3, 0, amp3);
	var fm2= SinOsc.ar(freq2*fm3, 0, amp2);
	var fm1= SinOsc.ar(freq1+fm2, 0, amp1);
	var fm= SinOsc.ar(freq+fm1+fm2, 0, amp);
	Out.ar(0, Pan2.ar(fm, pan, env));
}).add;
)
a= Synth(\subnetFM)		//create a synth from the definition
a.publish(\fmSynth)		//open synth for external control


//now run the openobject_demo_overview.maxpat in maxmsp
//or openobject_demo_overview.pd in puredata
//or openobject_demo_overview.pde in processing


a.free
a.unpublish(\fmSynth)
OpenObject.end










a.set(\freq1, 451, \amp1, 623, \freq2, 579, \amp2, 328, \freq3, 5, \amp3, 776)
a.set(\freq1, 10, \amp1, 200, \freq2, 1580, \amp2, 450, \freq3, 5, \amp3, 776)
a.set(\freq1, 6, \amp1, 654, \freq2, 3, \amp2, 150, \freq3, 1.2, \amp3, 0.6)
a.set(\freq1, 838, \amp1, 227, \freq2, 688, \amp2, 500, \freq3, 50, \amp3, 332)

a.set(\freq1, 1000.rand, \freq2, 1000.rand, \freq3, 1000.rand, \amp1, 1000.rand, \amp2, 1000.rand, \amp3, 1000.rand)
a.trace
a.set(\amp, 0.1)
a.free